# frozen_string_literal: true
require "gakubuchi/task"
require "rake"
require "rake/tasklib"
require "sprockets/railtie"

rake_tasks do
  ::Gakubuchi::RakeTask.new do |task|
    task.templates = %w(foo.slim bar.slim)
  end
end

module Gakubuchi
  class RakeTask < ::Rake::TaskLib
    attr_accessor :templates

    def initialize(target_task = "assets:precompile")
      self.target_task = target_task
      self.templates = []
      self.verbose = true

      yield self if block_given?
      enhance_target_task
    end

    def task
      @task ||= ::Gakubuchi::Task.new(templates, verbose: verbose)
    end

    private

    def enhance_target_task
      ::Rake::Task[target_task].enhance { task.execute! }
    end
  end
end
